diff --git a/Firmware/Chameleon-Mini/Application/CryptoAES128.c b/Firmware/Chameleon-Mini/Application/CryptoAES128.c
index 321b0273..74b2ac2c 100644
--- a/Firmware/Chameleon-Mini/Application/CryptoAES128.c
+++ b/Firmware/Chameleon-Mini/Application/CryptoAES128.c
@@ -45,7 +45,7 @@ static aes_callback_t __CryptoAESCallbackFunc = NULL;
 static CryptoAESBlock_t __CryptoAES_IVData = { 0 };
 
 /* Set the last operation mode (ECB or CBC) init for the context */
-static uint8_t __CryptoAESOpMode = CRYPTO_AES_CBC_MODE;
+static uint8_t __CryptoAESOpMode = CRYPTO_AES_ECB_MODE;
 
 void aes_start(void) {
     AES.CTRL |= AES_START_bm;
@@ -238,16 +238,18 @@ static void CryptoAESDecryptBlock(uint8_t *Plaintext, uint8_t *Ciphertext, const
 
 uint8_t CryptoAESEncryptBuffer(uint16_t Count, uint8_t *Plaintext, uint8_t *Ciphertext,
                                const uint8_t *IV, const uint8_t *Key) {
+    bool copyIVBuffer = true;
     if ((Count % CRYPTO_AES_BLOCK_SIZE) != 0) {
         return 0xBE;
     } else if (IV == NULL) {
         memset(__CryptoAES_IVData, 0x00, CRYPTO_AES_BLOCK_SIZE);
         IV = &__CryptoAES_IVData[0];
+        copyIVBuffer = false;
     }
+    CryptoAESBlock_t inputBlock;
     size_t bufBlocks = (Count + CRYPTO_AES_BLOCK_SIZE - 1) / CRYPTO_AES_BLOCK_SIZE;
     for (int blk = 0; blk < bufBlocks; blk++) {
         if (__CryptoAESOpMode == CRYPTO_AES_CBC_MODE) {
-            CryptoAESBlock_t inputBlock;
             if (blk == 0) {
                 memcpy(inputBlock, &Plaintext[0], CRYPTO_AES_BLOCK_SIZE);
                 CryptoMemoryXOR(IV, inputBlock, CRYPTO_AES_BLOCK_SIZE);
@@ -256,9 +258,14 @@ uint8_t CryptoAESEncryptBuffer(uint16_t Count, uint8_t *Plaintext, uint8_t *Ciph
                 CryptoMemoryXOR(&Plaintext[blk * CRYPTO_AES_BLOCK_SIZE], inputBlock, CRYPTO_AES_BLOCK_SIZE);
             }
             CryptoAESEncryptBlock(inputBlock, Ciphertext + blk * CRYPTO_AES_BLOCK_SIZE, Key, true);
+            if (blk + 1 == bufBlocks && copyIVBuffer) {
+                memcpy(IV, inputBlock, CRYPTO_AES_BLOCK_SIZE);
+            }
         } else {
-            CryptoAESEncryptBlock(Plaintext + blk * CRYPTO_AES_BLOCK_SIZE,
-                                  Ciphertext + blk * CRYPTO_AES_BLOCK_SIZE, Key, true);
+            memcpy(inputBlock, Plaintext + blk * CRYPTO_AES_BLOCK_SIZE, CRYPTO_AES_BLOCK_SIZE);
+            CryptoMemoryXOR(IV, inputBlock, CRYPTO_AES_BLOCK_SIZE);
+            CryptoAESEncryptBlock(inputBlock, Ciphertext + blk * CRYPTO_AES_BLOCK_SIZE, Key, true);
+            memcpy(IV, Ciphertext + blk * CRYPTO_AES_BLOCK_SIZE, CRYPTO_AES_BLOCK_SIZE);
         }
     }
     return 0;
@@ -266,16 +273,18 @@ uint8_t CryptoAESEncryptBuffer(uint16_t Count, uint8_t *Plaintext, uint8_t *Ciph
 
 uint8_t CryptoAESDecryptBuffer(uint16_t Count, uint8_t *Plaintext, uint8_t *Ciphertext,
                                const uint8_t *IV, const uint8_t *Key) {
+    bool copyIVBuffer = true;
     if ((Count % CRYPTO_AES_BLOCK_SIZE) != 0) {
         return 0xBE;
     } else if (IV == NULL) {
         memset(__CryptoAES_IVData, 0x00, CRYPTO_AES_BLOCK_SIZE);
         IV = &__CryptoAES_IVData[0];
+        copyIVBuffer = false;
     }
+    CryptoAESBlock_t inputBlock;
     size_t bufBlocks = (Count + CRYPTO_AES_BLOCK_SIZE - 1) / CRYPTO_AES_BLOCK_SIZE;
     for (int blk = 0; blk < bufBlocks; blk++) {
         if (__CryptoAESOpMode == CRYPTO_AES_CBC_MODE) {
-            CryptoAESBlock_t inputBlock;
             CryptoAESDecryptBlock(inputBlock, Ciphertext + blk * CRYPTO_AES_BLOCK_SIZE, Key);
             if (blk == 0) {
                 memcpy(Plaintext + blk * CRYPTO_AES_BLOCK_SIZE, inputBlock, CRYPTO_AES_BLOCK_SIZE);
@@ -285,9 +294,14 @@ uint8_t CryptoAESDecryptBuffer(uint16_t Count, uint8_t *Plaintext, uint8_t *Ciph
                 CryptoMemoryXOR(&Ciphertext[(blk - 1) * CRYPTO_AES_BLOCK_SIZE],
                                 Plaintext + blk * CRYPTO_AES_BLOCK_SIZE, CRYPTO_AES_BLOCK_SIZE);
             }
+            if (blk + 1 == bufBlocks && copyIVBuffer) {
+                memcpy(IV, inputBlock, CRYPTO_AES_BLOCK_SIZE);
+            }
         } else {
             CryptoAESDecryptBlock(Plaintext + blk * CRYPTO_AES_BLOCK_SIZE,
                                   Ciphertext + blk * CRYPTO_AES_BLOCK_SIZE, Key);
+            CryptoMemoryXOR(IV, Plaintext + blk * CRYPTO_AES_BLOCK_SIZE, CRYPTO_AES_BLOCK_SIZE);
+            memcpy(IV, Ciphertext + blk * CRYPTO_AES_BLOCK_SIZE, CRYPTO_AES_BLOCK_SIZE);
         }
     }
     return 0;
diff --git a/Firmware/Chameleon-Mini/Application/CryptoTDEA.c b/Firmware/Chameleon-Mini/Application/CryptoTDEA.c
index 78145671..2b773186 100644
--- a/Firmware/Chameleon-Mini/Application/CryptoTDEA.c
+++ b/Firmware/Chameleon-Mini/Application/CryptoTDEA.c
@@ -8,12 +8,14 @@
 #include "CryptoTDEA.h"
 #include "CryptoAES128.h"
 
+/* Set the last operation mode (ECB or CBC) init for the context */
+static uint8_t __CryptoDESOpMode = CRYPTO_DES_ECB_MODE;
+
 static void CryptoEncryptCBCBuffer(CryptoTDEA_CBCSpec *CryptoSpec, uint16_t Count, const void *Plaintext, void *Ciphertext, const uint8_t *IVIn, const uint8_t *Keys);
 static void CryptoEncryptCBCBuffer(CryptoTDEA_CBCSpec *CryptoSpec, uint16_t Count, const void *Plaintext, void *Ciphertext, const uint8_t *IVIn, const uint8_t *Keys) {
     uint16_t numBlocks = (Count + CryptoSpec->blockSize - 1) / CryptoSpec->blockSize;
     bool dataNeedsPadding = (Count % CryptoSpec->blockSize) != 0;
     uint16_t blockIndex = 0;
-    uint8_t *ctBuf = (uint8_t *) Ciphertext;
     uint8_t inputBlock[CryptoSpec->blockSize];
     uint8_t IV[CryptoSpec->blockSize];
     if (IVIn == NULL) {
@@ -22,22 +24,31 @@ static void CryptoEncryptCBCBuffer(CryptoTDEA_CBCSpec *CryptoSpec, uint16_t Coun
         memcpy(IV, IVIn, CryptoSpec->blockSize);
     }
     while (blockIndex < numBlocks) {
-        if (blockIndex == 0) {
-            memset(inputBlock, 0x00, CryptoSpec->blockSize);
-            memcpy(inputBlock, &Plaintext[0], CryptoSpec->blockSize);
+        if (__CryptoDESOpMode == CRYPTO_DES_CBC_MODE) {
+            if (blockIndex == 0) {
+                memset(inputBlock, 0x00, CryptoSpec->blockSize);
+                memcpy(inputBlock, &Plaintext[0], CryptoSpec->blockSize);
+                CryptoMemoryXOR(IV, inputBlock, CryptoSpec->blockSize);
+            } else if (dataNeedsPadding && blockIndex + 1 == numBlocks) {
+                memset(inputBlock, 0x00, CryptoSpec->blockSize);
+                memcpy(inputBlock, &Ciphertext[(blockIndex - 1) * CryptoSpec->blockSize], Count % CryptoSpec->blockSize);
+                CryptoMemoryXOR(&Plaintext[blockIndex * CryptoSpec->blockSize], inputBlock, CryptoSpec->blockSize);
+            } else {
+                memcpy(inputBlock, &Ciphertext[(blockIndex - 1) * CryptoSpec->blockSize], CryptoSpec->blockSize);
+                CryptoMemoryXOR(&Plaintext[blockIndex * CryptoSpec->blockSize], inputBlock, CryptoSpec->blockSize);
+            }
+            CryptoSpec->cryptFunc(inputBlock, &Ciphertext[blockIndex * CryptoSpec->blockSize], Keys);
+        } else { /* ECB mode */
+            memcpy(inputBlock, &Plaintext[blockIndex * CryptoSpec->blockSize], CryptoSpec->blockSize);
             CryptoMemoryXOR(IV, inputBlock, CryptoSpec->blockSize);
-        } else if (dataNeedsPadding && blockIndex + 1 == numBlocks) {
-            memset(inputBlock, 0x00, CryptoSpec->blockSize);
-            memcpy(inputBlock, &Ciphertext[(blockIndex - 1) * CryptoSpec->blockSize], Count % CryptoSpec->blockSize);
-            CryptoMemoryXOR(&Plaintext[blockIndex * CryptoSpec->blockSize], inputBlock, CryptoSpec->blockSize);
-        } else {
-            memcpy(inputBlock, &Ciphertext[(blockIndex - 1) * CryptoSpec->blockSize], CryptoSpec->blockSize);
-            CryptoMemoryXOR(&Plaintext[blockIndex * CryptoSpec->blockSize], inputBlock, CryptoSpec->blockSize);
+            CryptoSpec->cryptFunc(inputBlock, &Ciphertext[blockIndex * CryptoSpec->blockSize], Keys);
+            memcpy(IV, &Ciphertext[blockIndex * CryptoSpec->blockSize], CryptoSpec->blockSize);
         }
-        CryptoSpec->cryptFunc(inputBlock, ctBuf, Keys);
-        ctBuf += CryptoSpec->blockSize;
         blockIndex++;
     }
+    if (IVIn != NULL) {
+        memcpy(IVIn, IV, CryptoSpec->blockSize);
+    }
 }
 
 static void CryptoDecryptCBCBuffer(CryptoTDEA_CBCSpec *CryptoSpec, uint16_t Count, void *Plaintext, const void *Ciphertext, const uint8_t *IVIn, const uint8_t *Keys);
@@ -53,24 +64,34 @@ static void CryptoDecryptCBCBuffer(CryptoTDEA_CBCSpec *CryptoSpec, uint16_t Coun
         memcpy(IV, IVIn, CryptoSpec->blockSize);
     }
     while (blockIndex < numBlocks) {
-        CryptoSpec->cryptFunc(inputBlock, Ciphertext + blockIndex * CryptoSpec->blockSize, Keys);
-        if (blockIndex == 0 && !dataNeedsPadding) {
-            memcpy(Plaintext, inputBlock, CryptoSpec->blockSize);
-            CryptoMemoryXOR(IV, Plaintext, CryptoSpec->blockSize);
-        } else if (blockIndex == 0 && dataNeedsPadding && numBlocks == 0x01) {
-            memcpy(Plaintext, inputBlock, Count % CryptoSpec->blockSize);
-            CryptoMemoryXOR(IV, Plaintext, Count % CryptoSpec->blockSize);
-        } else if (dataNeedsPadding && blockIndex + 1 == numBlocks) {
-            memcpy(Plaintext + blockIndex * CryptoSpec->blockSize, inputBlock, Count % CryptoSpec->blockSize);
-            CryptoMemoryXOR(&Ciphertext[(blockIndex - 1) * CryptoSpec->blockSize],
-                            Plaintext + blockIndex * CryptoSpec->blockSize, Count % CryptoSpec->blockSize);
-        } else {
-            memcpy(Plaintext + blockIndex * CryptoSpec->blockSize, inputBlock, CryptoSpec->blockSize);
-            CryptoMemoryXOR(&Ciphertext[(blockIndex - 1) * CryptoSpec->blockSize],
-                            Plaintext + blockIndex * CryptoSpec->blockSize, CryptoSpec->blockSize);
+        if (__CryptoDESOpMode == CRYPTO_DES_CBC_MODE) {
+            CryptoSpec->cryptFunc(inputBlock, Ciphertext + blockIndex * CryptoSpec->blockSize, Keys);
+            if (blockIndex == 0 && !dataNeedsPadding) {
+                memcpy(Plaintext, inputBlock, CryptoSpec->blockSize);
+                CryptoMemoryXOR(IV, Plaintext, CryptoSpec->blockSize);
+            } else if (blockIndex == 0 && dataNeedsPadding && numBlocks == 0x01) {
+                memcpy(Plaintext, inputBlock, Count % CryptoSpec->blockSize);
+                CryptoMemoryXOR(IV, Plaintext, Count % CryptoSpec->blockSize);
+            } else if (dataNeedsPadding && blockIndex + 1 == numBlocks) {
+                memcpy(Plaintext + blockIndex * CryptoSpec->blockSize, inputBlock, Count % CryptoSpec->blockSize);
+                CryptoMemoryXOR(&Ciphertext[(blockIndex - 1) * CryptoSpec->blockSize],
+                                Plaintext + blockIndex * CryptoSpec->blockSize, Count % CryptoSpec->blockSize);
+            } else {
+                memcpy(Plaintext + blockIndex * CryptoSpec->blockSize, inputBlock, CryptoSpec->blockSize);
+                CryptoMemoryXOR(&Ciphertext[(blockIndex - 1) * CryptoSpec->blockSize],
+                                Plaintext + blockIndex * CryptoSpec->blockSize, CryptoSpec->blockSize);
+            }
+        } else { /* ECB mode */
+            CryptoSpec->cryptFunc(&Plaintext[blockIndex * CryptoSpec->blockSize],
+                                  &Ciphertext[blockIndex * CryptoSpec->blockSize], Keys);
+            CryptoMemoryXOR(IV, &Plaintext[blockIndex * CryptoSpec->blockSize], CryptoSpec->blockSize);
+            memcpy(IV, &Ciphertext[blockIndex * CryptoSpec->blockSize], CryptoSpec->blockSize);
         }
         blockIndex++;
     }
+    if (IVIn != NULL) {
+        memcpy(IVIn, IV, CryptoSpec->blockSize);
+    }
 }
 
 void EncryptDESBuffer(uint16_t Count, const void *Plaintext, void *Ciphertext, const uint8_t *IVIn, const uint8_t *Keys) {
diff --git a/Firmware/Chameleon-Mini/Application/CryptoTDEA.h b/Firmware/Chameleon-Mini/Application/CryptoTDEA.h
index 6397e900..8eed3e47 100644
--- a/Firmware/Chameleon-Mini/Application/CryptoTDEA.h
+++ b/Firmware/Chameleon-Mini/Application/CryptoTDEA.h
@@ -27,6 +27,10 @@ PCD's side.
 
 */
 
+/* DES Operation cipher mode */
+#define CRYPTO_DES_ECB_MODE                0     // Electronic Code Book mode
+#define CRYPTO_DES_CBC_MODE                1     // Cipher Block Chaining mode
+
 /* Key sizes, in bytes */
 #define CRYPTO_DES_KEY_SIZE         8 /* Bytes */
 #define CRYPTO_2KTDEA_KEY_SIZE      (CRYPTO_DES_KEY_SIZE * 2)
diff --git a/Firmware/Chameleon-Mini/Application/DESFire/DESFireCrypto.c b/Firmware/Chameleon-Mini/Application/DESFire/DESFireCrypto.c
index 8bd8db28..268e86c7 100644
--- a/Firmware/Chameleon-Mini/Application/DESFire/DESFireCrypto.c
+++ b/Firmware/Chameleon-Mini/Application/DESFire/DESFireCrypto.c
@@ -63,6 +63,8 @@ void InvalidateAuthState(BYTE keepPICCAuthData) {
     CryptoAuthMethod = CRYPTO_TYPE_ANY;
     ActiveCommMode = DESFIRE_DEFAULT_COMMS_STANDARD;
     DesfireCommMode = ActiveCommMode;
+    memset(&SessionKey[0], 0x00, CRYPTO_MAX_BLOCK_SIZE);
+    memset(&SessionIV[0], 0x00, CRYPTO_MAX_BLOCK_SIZE);
 }
 
 bool IsAuthenticated(void) {
diff --git a/Firmware/Chameleon-Mini/Application/DESFire/DESFireISO14443Support.c b/Firmware/Chameleon-Mini/Application/DESFire/DESFireISO14443Support.c
index 58345e88..78d6b189 100644
--- a/Firmware/Chameleon-Mini/Application/DESFire/DESFireISO14443Support.c
+++ b/Firmware/Chameleon-Mini/Application/DESFire/DESFireISO14443Support.c
@@ -419,7 +419,8 @@ uint16_t ISO144433APiccProcess(uint8_t *Buffer, uint16_t BitCount) {
                 const char *logMsg = PSTR("ISO14443-3/4: EXPECTING RATS");
                 LogDebuggingMsg(logMsg);
             } else if (Cmd == ISO14443A_CMD_SELECT_CL3) {
-                return ISO14443A_APP_NO_RESPONSE;
+                Buffer[0] = 0x00;
+                return 1 * BITS_PER_BYTE;
             }
             /* Forward to ISO/IEC 14443-4 processing code */
             uint16_t ByteCount = (BitCount + BITS_PER_BYTE - 1) / BITS_PER_BYTE;
diff --git a/Firmware/Chameleon-Mini/Application/DESFire/DESFireInstructions.c b/Firmware/Chameleon-Mini/Application/DESFire/DESFireInstructions.c
index 73b6e1bf..cd746565 100644
--- a/Firmware/Chameleon-Mini/Application/DESFire/DESFireInstructions.c
+++ b/Firmware/Chameleon-Mini/Application/DESFire/DESFireInstructions.c
@@ -1714,7 +1714,7 @@ uint16_t DesfireCmdAuthenticate3KTDEA1(uint8_t *Buffer, uint16_t ByteCount) {
     BYTE KeyId, Status;
     BYTE keySize;
     BYTE CryptoChallengeResponseBytesSize;
-    BYTE *Key;
+    BYTE *Key, *IV;
 
     /* Validate command length */
     if (ByteCount != 2) {
@@ -1744,6 +1744,7 @@ uint16_t DesfireCmdAuthenticate3KTDEA1(uint8_t *Buffer, uint16_t ByteCount) {
 
     /* Update state */
     Key = SessionKey;
+    IV = SessionIV;
     DesfireCommandState.KeyId = KeyId;
     BYTE cryptoKeyType = ReadKeyCryptoType(SelectedApp.Slot, KeyId);
     if (cryptoKeyType == CRYPTO_TYPE_ANY || cryptoKeyType == CRYPTO_TYPE_3K3DES) {
@@ -1798,12 +1799,13 @@ uint16_t DesfireCmdAuthenticate3KTDEA1(uint8_t *Buffer, uint16_t ByteCount) {
     LogEntry(LOG_APP_NONCE_B, DesfireCommandState.RndB, CryptoChallengeResponseBytesSize);
 
     /* Encrypt RndB with the selected key and transfer it back to the PCD */
-    if (cryptoKeyType == CRYPTO_TYPE_DES || cryptoKeyType == CRYPTO_TYPE_3K3DES || cryptoKeyType == CRYPTO_TYPE_ANY) {
+    if (cryptoKeyType == CRYPTO_TYPE_DES || cryptoKeyType == CRYPTO_TYPE_3K3DES ||
+            cryptoKeyType == CRYPTO_TYPE_ANY) {
         Encrypt3DESBuffer(CryptoChallengeResponseBytesSize, DesfireCommandState.RndB,
-                          &Buffer[1], NULL, Key);
+                          &Buffer[1], IV, Key);
     } else {
         Encrypt2K3DESBuffer(CryptoChallengeResponseBytesSize, DesfireCommandState.RndB,
-                            &Buffer[1], NULL, Key);
+                            &Buffer[1], IV, Key);
     }
 
     /* Scrub the key */
@@ -1820,10 +1822,9 @@ uint16_t DesfireCmdAuthenticate3KTDEA2(uint8_t *Buffer, uint16_t ByteCount) {
     BYTE KeyId;
     BYTE cryptoKeyType, keySize;
     BYTE CryptoChallengeResponseBytesSize;
-    BYTE *Key;
+    BYTE *Key, *IV;
 
     cryptoKeyType = DesfireCommandState.CryptoMethodType;
-    keySize = GetDefaultCryptoMethodKeySize(cryptoKeyType);
     if (cryptoKeyType == CRYPTO_TYPE_ANY || cryptoKeyType == CRYPTO_TYPE_3K3DES) {
         CryptoChallengeResponseBytesSize = CRYPTO_CHALLENGE_RESPONSE_BYTES;
     } else if (cryptoKeyType == CRYPTO_TYPE_DES) {
@@ -1837,15 +1838,15 @@ uint16_t DesfireCmdAuthenticate3KTDEA2(uint8_t *Buffer, uint16_t ByteCount) {
     /* Validate command length */
     if (ByteCount != 2 * CryptoChallengeResponseBytesSize + 1) {
         Buffer[0] = STATUS_LENGTH_ERROR;
-        Buffer[1] = ByteCount;
-        Buffer[2] = CryptoChallengeResponseBytesSize;
-        return 3 * DESFIRE_STATUS_RESPONSE_SIZE;
+        return DESFIRE_STATUS_RESPONSE_SIZE;
     }
 
     /* Reset parameters for authentication from the first exchange */
+    keySize = GetDefaultCryptoMethodKeySize(cryptoKeyType);
     KeyId = DesfireCommandState.KeyId;
     Key = SessionKey;
     ReadAppKey(SelectedApp.Slot, KeyId, Key, keySize);
+    IV = SessionIV;
     if (DesfireCommandState.CryptoMethodType == CRYPTO_TYPE_DES) {
         memcpy(&Key[CRYPTO_DES_BLOCK_SIZE], &Key[0], CRYPTO_DES_BLOCK_SIZE);
         memcpy(&Key[2 * CRYPTO_DES_BLOCK_SIZE], &Key[0], CRYPTO_DES_BLOCK_SIZE);
@@ -1855,32 +1856,35 @@ uint16_t DesfireCmdAuthenticate3KTDEA2(uint8_t *Buffer, uint16_t ByteCount) {
     BYTE challengeRndAB[2 * CryptoChallengeResponseBytesSize];
     BYTE challengeRndA[CryptoChallengeResponseBytesSize];
     BYTE challengeRndB[CryptoChallengeResponseBytesSize];
-    if (cryptoKeyType == CRYPTO_TYPE_DES || cryptoKeyType == CRYPTO_TYPE_3K3DES || cryptoKeyType == CRYPTO_TYPE_ANY) {
+    if (cryptoKeyType == CRYPTO_TYPE_DES || cryptoKeyType == CRYPTO_TYPE_3K3DES ||
+            cryptoKeyType == CRYPTO_TYPE_ANY) {
         Decrypt3DESBuffer(2 * CryptoChallengeResponseBytesSize, challengeRndAB,
-                          &Buffer[1], NULL, Key);
+                          &Buffer[1], IV, Key);
     } else {
         Decrypt2K3DESBuffer(2 * CryptoChallengeResponseBytesSize, challengeRndAB,
-                            &Buffer[1], NULL, Key);
+                            &Buffer[1], IV, Key);
     }
-    RotateArrayRight(challengeRndAB + CryptoChallengeResponseBytesSize, challengeRndB,
-                     CryptoChallengeResponseBytesSize);
+    RotateArrayLeft(challengeRndAB + CryptoChallengeResponseBytesSize, challengeRndB,
+                    CryptoChallengeResponseBytesSize);
     memcpy(challengeRndA, challengeRndAB, CryptoChallengeResponseBytesSize);
 
     /* Check that the returned RndB matches what we sent in the previous round */
     if (memcmp(DesfireCommandState.RndB, challengeRndB, CryptoChallengeResponseBytesSize)) {
-        LogEntry(LOG_ERR_DESFIRE_GENERIC_ERROR, (const void *) challengeRndB, CryptoChallengeResponseBytesSize);
+        LogEntry(LOG_ERR_DESFIRE_GENERIC_ERROR, (const void *) challengeRndB,
+                 CryptoChallengeResponseBytesSize);
         Buffer[0] = STATUS_AUTHENTICATION_ERROR;
         return DESFIRE_STATUS_RESPONSE_SIZE;
     }
 
     /* Encrypt and send back the once rotated RndA buffer to the PCD */
-    RotateArrayLeft(challengeRndA, challengeRndAB, CryptoChallengeResponseBytesSize);
-    if (cryptoKeyType == CRYPTO_TYPE_DES || cryptoKeyType == CRYPTO_TYPE_3K3DES || cryptoKeyType == CRYPTO_TYPE_ANY) {
+    RotateArrayRight(challengeRndA, challengeRndAB, CryptoChallengeResponseBytesSize);
+    if (cryptoKeyType == CRYPTO_TYPE_DES || cryptoKeyType == CRYPTO_TYPE_3K3DES ||
+            cryptoKeyType == CRYPTO_TYPE_ANY) {
         Encrypt3DESBuffer(CryptoChallengeResponseBytesSize, challengeRndAB,
-                          &Buffer[1], NULL, Key);
+                          &Buffer[1], IV, Key);
     } else {
         Encrypt2K3DESBuffer(CryptoChallengeResponseBytesSize, challengeRndAB,
-                            &Buffer[1], NULL, Key);
+                            &Buffer[1], IV, Key);
     }
 
     /* Create the session key based on the previous exchange */
@@ -1983,7 +1987,8 @@ uint16_t DesfireCmdAuthenticateAES1(uint8_t *Buffer, uint16_t ByteCount) {
     LogEntry(LOG_APP_NONCE_B, DesfireCommandState.RndB, CRYPTO_CHALLENGE_RESPONSE_BYTES);
 
     /* Encrypt RndB with the selected key and transfer it back to the PCD */
-    Status = CryptoAESEncryptBuffer(CRYPTO_CHALLENGE_RESPONSE_BYTES, DesfireCommandState.RndB, &Buffer[1], NULL, Key);
+    Status = CryptoAESEncryptBuffer(CRYPTO_CHALLENGE_RESPONSE_BYTES, DesfireCommandState.RndB,
+                                    &Buffer[1], IVBuffer, Key);
     if (Status != STATUS_OPERATION_OK) {
         Buffer[0] = Status;
         return DESFIRE_STATUS_RESPONSE_SIZE;
@@ -2002,7 +2007,7 @@ uint16_t DesfireCmdAuthenticateAES1(uint8_t *Buffer, uint16_t ByteCount) {
 uint16_t DesfireCmdAuthenticateAES2(uint8_t *Buffer, uint16_t ByteCount) {
     BYTE KeyId;
     BYTE cryptoKeyType, keySize;
-    BYTE *Key;
+    BYTE *Key, *IVBuffer;
 
     /* Set status for the next incoming command on error */
     DesfireState = DESFIRE_IDLE;
@@ -2018,13 +2023,14 @@ uint16_t DesfireCmdAuthenticateAES2(uint8_t *Buffer, uint16_t ByteCount) {
     KeyId = DesfireCommandState.KeyId;
     cryptoKeyType = DesfireCommandState.CryptoMethodType;
     ReadAppKey(SelectedApp.Slot, KeyId, Key, keySize);
+    IVBuffer = SessionIV;
 
     /* Decrypt the challenge sent back to get RndA and a shifted RndB */
     BYTE challengeRndAB[2 * CRYPTO_CHALLENGE_RESPONSE_BYTES];
     BYTE challengeRndA[CRYPTO_CHALLENGE_RESPONSE_BYTES];
     BYTE challengeRndB[CRYPTO_CHALLENGE_RESPONSE_BYTES];
-    CryptoAESDecryptBuffer(2 * CRYPTO_CHALLENGE_RESPONSE_BYTES, challengeRndAB, &Buffer[1], NULL, Key);
-    RotateArrayRight(challengeRndAB + CRYPTO_CHALLENGE_RESPONSE_BYTES, challengeRndB, CRYPTO_CHALLENGE_RESPONSE_BYTES);
+    CryptoAESDecryptBuffer(2 * CRYPTO_CHALLENGE_RESPONSE_BYTES, challengeRndAB, &Buffer[1], IVBuffer, Key);
+    RotateArrayLeft(challengeRndAB + CRYPTO_CHALLENGE_RESPONSE_BYTES, challengeRndB, CRYPTO_CHALLENGE_RESPONSE_BYTES);
     memcpy(challengeRndA, challengeRndAB, CRYPTO_CHALLENGE_RESPONSE_BYTES);
 
     /* Check that the returned RndB matches what we sent in the previous round */
@@ -2036,10 +2042,8 @@ uint16_t DesfireCmdAuthenticateAES2(uint8_t *Buffer, uint16_t ByteCount) {
     }
 
     /* Encrypt and send back the once rotated RndA buffer to the PCD */
-    memset(challengeRndAB, 0x00, CRYPTO_CHALLENGE_RESPONSE_BYTES);
-    memcpy(challengeRndAB, challengeRndA, CRYPTO_CHALLENGE_RESPONSE_BYTES);
-    RotateArrayLeft(challengeRndA, challengeRndAB, CRYPTO_CHALLENGE_RESPONSE_BYTES);
-    CryptoAESEncryptBuffer(CRYPTO_CHALLENGE_RESPONSE_BYTES, challengeRndAB, &Buffer[1], NULL, Key);
+    RotateArrayRight(challengeRndA, challengeRndAB, CRYPTO_CHALLENGE_RESPONSE_BYTES);
+    CryptoAESEncryptBuffer(CRYPTO_CHALLENGE_RESPONSE_BYTES, challengeRndA, &Buffer[1], IVBuffer, Key);
 
     /* Create the session key based on the previous exchange */
     generateSessionKey(SessionKey, challengeRndA, challengeRndB, CRYPTO_TYPE_AES128);
diff --git a/Firmware/Chameleon-Mini/Application/MifareDESFire.c b/Firmware/Chameleon-Mini/Application/MifareDESFire.c
index 82f267d1..5ffd057b 100644
--- a/Firmware/Chameleon-Mini/Application/MifareDESFire.c
+++ b/Firmware/Chameleon-Mini/Application/MifareDESFire.c
@@ -179,7 +179,9 @@ uint16_t MifareDesfireProcess(uint8_t *Buffer, uint16_t BitCount) {
     if (BitCount == 0) {
         LogEntry(LOG_INFO_DESFIRE_INCOMING_DATA, Buffer, ByteCount);
         return ISO14443A_APP_NO_RESPONSE;
-    } else if (((ByteCount >= 8 && Buffer[4] == ByteCount - 8) || (ByteCount >= 5 && Buffer[4] == ByteCount - 5)) &&
+    } else if (((ByteCount >= 8 && Buffer[4] == ByteCount - 8) ||
+                (ByteCount >= 5 && Buffer[4] == ByteCount - 5) ||
+                (ByteCount >= 5 && Buffer[1] == STATUS_ADDITIONAL_FRAME)) &&
                DesfireCLA(Buffer[0]) && Buffer[2] == 0x00 &&
                Buffer[3] == 0x00 || Iso7816CLA(DesfireCmdCLA)) {
         /* Wrapped native command structure or ISO7816: */
@@ -243,12 +245,12 @@ uint16_t MifareDesfireAppProcess(uint8_t *Buffer, uint16_t BitCount) {
             Buffer[0] = DesfireCmdCLA;
             Buffer[1] = STATUS_ADDITIONAL_FRAME;
             if (ByteCount > 3) {
-                memmove(&Buffer[3], &Buffer[5], ByteCount - 3);
+                memmove(&Buffer[5], &Buffer[3], ByteCount - 3);
             }
             Buffer[2] = 0x00;
             Buffer[3] = 0x00;
-            Buffer[4] = ByteCount - 3;
-            ByteCount += 1;
+            Buffer[4] = ByteCount - 5;
+            ByteCount += 2;
         } else if (Iso7816CmdType == ISO7816_WRAPPED_CMD_TYPE_PM3RAW) {
             /* Something like the following (for PM3 raw ISO auth):
              * 0a 00 1a 00 CRC1 CRC2 -- first two are prologue -- last two are checksum
